/********************************************************************** 
 * Copyright (c) 2015 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at 
 * http://www.eclipse.org/legal/epl-v10.html 
 * 
 * Contributors: 
 * IBM - Initial API and implementation 
 **********************************************************************/
package org.eclipse.hyades.automation.core;

public interface IAutomationPreProcessor {
	
	/**
	 * 
	 * @param command - system property "tptp.automation.command" currently only "execute" is used
	 * @return true if automation can continue
	 */
	boolean preProcess(String command);

}
