/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ExecutionFacadeResourceFactoryImpl.java,v 1.7 2009-01-09 12:33:58 paules Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.models.common.facades.behavioral.impl;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;

/**
 * @deprecated Use {@link FacadeResourceFactoryImpl}.
 */
public class ExecutionFacadeResourceFactoryImpl extends
		FacadeResourceFactoryImpl
{
	/* (non-Javadoc)
	 * @see org.eclipse.emf.ecore.resource.impl.ResourceFactoryImpl#createResource(org.eclipse.emf.common.util.URI)
	 */
	public Resource createResource(URI arg0) {
		FacadeResourceImpl resource = new ExecutionFacadeResourceImpl(arg0);
		resource.setUseZip(true);
		resource.setEncoding(ENCODING);
		return resource;
	}
}
