/**********************************************************************
 * Copyright (c) 2006, 2012 Intel Corporation and IBM Corporation.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: MethodMaxTimeAttrLP.java,v 1.1 2006-09-21 19:19:29 ewchan Exp $
 * 
 **********************************************************************/
package org.eclipse.hyades.trace.views.internal.context.java.formatters;

import java.util.List;

import org.eclipse.hyades.trace.views.internal.TraceUIMessages;
import org.eclipse.hyades.ui.provisional.context.IContextLabelFormatProvider;

public class MethodMaxTimeAttrLP extends TimeAttrLP {
	public String getDisplayStringFromElement(Object value, Object element, int mode) {
		if (mode == IContextLabelFormatProvider.MODE_COLUMN_HEADER)
			return TraceUIMessages._248;
		else
			return super.getDisplayStringFromElement(value, element, mode);
	}	
	
	protected List<Integer> internalSupportModes()
	{
		List<Integer> modes = super.internalSupportModes();
		modes.add(new Integer(IContextLabelFormatProvider.MODE_COLUMN_HEADER));
		return modes;
	}
}
