/*******************************************************************************
 * Copyright (c) 2007 IBM Corporation, Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: PDEIntegrationMessages.java,v 1.1 2007-04-19 20:19:40 ewchan Exp $
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.tptp.platform.integration.pde.internal;

import org.eclipse.osgi.util.NLS;
import org.eclipse.tptp.platform.common.ui.trace.internal.CommonUITraceMessages;

public final class PDEIntegrationMessages extends CommonUITraceMessages
{

	private static final String BUNDLE_NAME = "org.eclipse.tptp.platform.integration.pde.internal.messages";//$NON-NLS-1$

	public static String JUnitLaunchShortcut_dialog_title2;
	public static String JUnitLaunchShortcut_message_selectTestToDebug;
	public static String JUnitLaunchShortcut_message_selectTestToRun;
	public static String JUnitLaunchShortcut_message_selectConfiguration;
	public static String JUnitLaunchShortcut_message_selectDebugConfiguration;
	public static String JUnitLaunchShortcut_message_selectRunConfiguration;
	
	static 
	{
		NLS.initializeMessages(BUNDLE_NAME, PDEIntegrationMessages.class);
	}
}