/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IDStringSerializable.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on 16 dc. 2003
 *
 */
package org.eclipse.tptp.platform.report.core.internal;

/**
 * Provides an interface to de/serialize data from/into a String.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IDStringSerializable
{
  /**
   * Returns a String used to serialize this object.
   */
  public String serializeToString();
  
  /**
   * Configures this object from a string.
   */
  public void serializeFromString( String s );
}
