/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IMarginLayout.java,v 1.2 2008-05-23 14:12:18 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/*
 * Created on 9 nov. 2004
 *
 */
package org.eclipse.tptp.platform.report.drivers.ui.layout.internal;

/**
 * @author emiravet
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public interface IMarginLayout extends ILayout{

    
    /** Returns the left margin */
    public int getLeftMargin();
    
    /** Returns the right margin */
    public int getRightMargin();
    
    /** Returns the top margin */
    public int getTopMargin();
    
    /** Returns the bottom margin */
    public int getBottomMargin();
    
    /** Sets the margin of the layout */
    public void setMargin(int l, int r, int t, int b);
    
    /** Returns the spacing between children in the layout */
	public int getSpacing();
	
	/** Sets the spacing between the children in the layout */
	public void setSpacing(int spacing);
    
}
