/********************************************************************** 
 * Copyright (c) 2004, 2006 IBM Corporation and others. 
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at 
 * http://www.eclipse.org/legal/epl-v10.html         
 * $Id: ProbeRegistryException.java,v 1.2 2006-02-06 20:18:19 nmehrega Exp $ 
 * 
 * Contributors: 
 * IBM - Initial API and implementation 
 **********************************************************************/ 

package org.eclipse.tptp.platform.probekit.registry;

/**
 * Base class for all exceptions defined by the Probekit Registry.
 * 
 * @author kcoleman
 */
public class ProbeRegistryException extends Exception {
	// TODO inherit from o.e.h.probekit ProbekitException later
	
    private static final long serialVersionUID = 3544677260881049140L;

    public ProbeRegistryException() {
		super();
	}

	public ProbeRegistryException(String message) {
		super(message);
	}

	public ProbeRegistryException(String message, Throwable cause) {
		super(message, cause);
	}

	public ProbeRegistryException(Throwable cause) {
		super(cause);
	}
}
