/*******************************************************************************
 * Copyright (c) 2005 Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Vishnu K Naikawadi, Intel - Header file for sample IDataProcessor impl.
 *
 * $Id: TimeDataProcessor.h,v 1.1 2005-10-29 00:13:52 kcallaghan Exp $
 *
 *******************************************************************************/ 

#ifndef  TimeDataProcessor_H
#define  TimeDataProcessor_H

#include "tptp/client/IDataProcessor.h"

using namespace TPTP::Client;

class TimeDataProcessor: public IDataProcessor
{
	public:
		TimeDataProcessor();
		~TimeDataProcessor();
		virtual void incomingData(char buffer[], int length, DIME_HEADER_PTR_T dimeHeader);
		virtual void invalidDataType(char data[], int length);
		virtual void waitingForData();		
};

#endif


