/**********************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DataChannelCreationException.java,v 1.2 2005-05-07 07:02:22 vnaikawadi Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.execution.exceptions;

/**
 *
 * Description:
 * 		Describes a data channel creation failure.
 *
 * Creation date: Apr 10, 2003
 *
 */
public class DataChannelCreationException extends Exception {
	private static final long serialVersionUID = 1L;
	
	public DataChannelCreationException(String msg) {
		super(msg);
	}

	public DataChannelCreationException() {
		super();
	}

}