/**********************************************************************
 * Copyright (c) 2005, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: InvalidMessageException.java,v 1.1 2007-04-09 14:04:24 samwai Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.execution.local.common;

public class InvalidMessageException extends Exception {

	/**
	 * Stream-Unique IDentifier (SUID) of this class
	 */
	private static final long serialVersionUID = -4943674624497132355L;

	/**
	 * InvalidMessageException constructor comment.
	 */
	public InvalidMessageException() {
		super();
	}

	/**
	 * InvalidMessageException constructor comment.
	 * 
	 * @param s
	 *            java.lang.String
	 */
	public InvalidMessageException(String s) {
		super(s);
	}
}
