/**********************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ExtendedLookupService.java,v 1.1 2007-11-27 04:28:30 apnan Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.loaders.util;

/**
 * @author slavescu
 */
public interface ExtendedLookupService extends LookupService{
    boolean deregister(HierarchyContext context, Class type, int key);
    boolean deregister(HierarchyContext context, Class type, long key);

//    Object locate(HierarchyContext context, int key);
//    Object locate(HierarchyContext context, long key);

    Object locate(HierarchyContext context, Class type, int key);
    Object locate(HierarchyContext context, Class type, long key);
}
