/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: HyadesDisplayHeightEnumeration.java,v 1.7 2009-05-05 15:46:21 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hyades Display Height Enumeration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_1 <em>DH 1</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_2 <em>DH 2</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_3 <em>DH 3</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_4 <em>DH 4</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_5 <em>DH 5</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_6 <em>DH 6</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_7 <em>DH 7</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_8 <em>DH 8</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration()
 * @model
 * @generated
 */
public interface HyadesDisplayHeightEnumeration extends CFGPsudoEnumeration{
	/**
	 * Returns the value of the '<em><b>DH 1</b></em>' attribute.
	 * The default value is <code>"480"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 1</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 1</em>' attribute.
	 * @see #setDH_1(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_1()
	 * @model default="480"
	 * @generated
	 */
	String getDH_1();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_1 <em>DH 1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 1</em>' attribute.
	 * @see #getDH_1()
	 * @generated
	 */
	void setDH_1(String value);

	/**
	 * Returns the value of the '<em><b>DH 2</b></em>' attribute.
	 * The default value is <code>"600"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 2</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 2</em>' attribute.
	 * @see #setDH_2(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_2()
	 * @model default="600"
	 * @generated
	 */
	String getDH_2();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_2 <em>DH 2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 2</em>' attribute.
	 * @see #getDH_2()
	 * @generated
	 */
	void setDH_2(String value);

	/**
	 * Returns the value of the '<em><b>DH 3</b></em>' attribute.
	 * The default value is <code>"768"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 3</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 3</em>' attribute.
	 * @see #setDH_3(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_3()
	 * @model default="768"
	 * @generated
	 */
	String getDH_3();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_3 <em>DH 3</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 3</em>' attribute.
	 * @see #getDH_3()
	 * @generated
	 */
	void setDH_3(String value);

	/**
	 * Returns the value of the '<em><b>DH 4</b></em>' attribute.
	 * The default value is <code>"1024"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 4</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 4</em>' attribute.
	 * @see #setDH_4(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_4()
	 * @model default="1024"
	 * @generated
	 */
	String getDH_4();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_4 <em>DH 4</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 4</em>' attribute.
	 * @see #getDH_4()
	 * @generated
	 */
	void setDH_4(String value);

	/**
	 * Returns the value of the '<em><b>DH 5</b></em>' attribute.
	 * The default value is <code>"1050"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 5</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 5</em>' attribute.
	 * @see #setDH_5(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_5()
	 * @model default="1050"
	 * @generated
	 */
	String getDH_5();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_5 <em>DH 5</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 5</em>' attribute.
	 * @see #getDH_5()
	 * @generated
	 */
	void setDH_5(String value);

	/**
	 * Returns the value of the '<em><b>DH 6</b></em>' attribute.
	 * The default value is <code>"1200"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 6</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 6</em>' attribute.
	 * @see #setDH_6(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_6()
	 * @model default="1200"
	 * @generated
	 */
	String getDH_6();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_6 <em>DH 6</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 6</em>' attribute.
	 * @see #getDH_6()
	 * @generated
	 */
	void setDH_6(String value);

	/**
	 * Returns the value of the '<em><b>DH 7</b></em>' attribute.
	 * The default value is <code>"1440"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 7</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 7</em>' attribute.
	 * @see #setDH_7(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_7()
	 * @model default="1440"
	 * @generated
	 */
	String getDH_7();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_7 <em>DH 7</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 7</em>' attribute.
	 * @see #getDH_7()
	 * @generated
	 */
	void setDH_7(String value);

	/**
	 * Returns the value of the '<em><b>DH 8</b></em>' attribute.
	 * The default value is <code>"1536"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>DH 8</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>DH 8</em>' attribute.
	 * @see #setDH_8(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getHyadesDisplayHeightEnumeration_DH_8()
	 * @model default="1536"
	 * @generated
	 */
	String getDH_8();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration#getDH_8 <em>DH 8</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>DH 8</em>' attribute.
	 * @see #getDH_8()
	 * @generated
	 */
	void setDH_8(String value);

} // HyadesDisplayHeightEnumeration
