/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: HyadesDisplayColorDepthEnumerationImpl.java,v 1.10 2009-05-05 15:46:19 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationFactory;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hyades Display Color Depth Enumeration</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_1 <em>DCD 1</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_2 <em>DCD 2</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_3 <em>DCD 3</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_4 <em>DCD 4</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_5 <em>DCD 5</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_6 <em>DCD 6</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_7 <em>DCD 7</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.impl.HyadesDisplayColorDepthEnumerationImpl#getDCD_8 <em>DCD 8</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class HyadesDisplayColorDepthEnumerationImpl extends CFGPsudoEnumerationImpl implements HyadesDisplayColorDepthEnumeration {
	/**
	 * The default value of the '{@link #getDCD_1() <em>DCD 1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_1()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_1_EDEFAULT = "1";

	/**
	 * The cached value of the '{@link #getDCD_1() <em>DCD 1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_1()
	 * @generated
	 * @ordered
	 */
	protected String dcD_1 = DCD_1_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_2() <em>DCD 2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_2()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_2_EDEFAULT = "4";

	/**
	 * The cached value of the '{@link #getDCD_2() <em>DCD 2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_2()
	 * @generated
	 * @ordered
	 */
	protected String dcD_2 = DCD_2_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_3() <em>DCD 3</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_3()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_3_EDEFAULT = "8";

	/**
	 * The cached value of the '{@link #getDCD_3() <em>DCD 3</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_3()
	 * @generated
	 * @ordered
	 */
	protected String dcD_3 = DCD_3_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_4() <em>DCD 4</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_4()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_4_EDEFAULT = "16";

	/**
	 * The cached value of the '{@link #getDCD_4() <em>DCD 4</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_4()
	 * @generated
	 * @ordered
	 */
	protected String dcD_4 = DCD_4_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_5() <em>DCD 5</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_5()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_5_EDEFAULT = "24";

	/**
	 * The cached value of the '{@link #getDCD_5() <em>DCD 5</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_5()
	 * @generated
	 * @ordered
	 */
	protected String dcD_5 = DCD_5_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_6() <em>DCD 6</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_6()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_6_EDEFAULT = "32";

	/**
	 * The cached value of the '{@link #getDCD_6() <em>DCD 6</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_6()
	 * @generated
	 * @ordered
	 */
	protected String dcD_6 = DCD_6_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_7() <em>DCD 7</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_7()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_7_EDEFAULT = "64";

	/**
	 * The cached value of the '{@link #getDCD_7() <em>DCD 7</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_7()
	 * @generated
	 * @ordered
	 */
	protected String dcD_7 = DCD_7_EDEFAULT;

	/**
	 * The default value of the '{@link #getDCD_8() <em>DCD 8</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_8()
	 * @generated
	 * @ordered
	 */
	protected static final String DCD_8_EDEFAULT = "128";

	/**
	 * The cached value of the '{@link #getDCD_8() <em>DCD 8</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDCD_8()
	 * @generated
	 * @ordered
	 */
	protected String dcD_8 = DCD_8_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected HyadesDisplayColorDepthEnumerationImpl()
	{
		super();
		this.setCategory(Common_ConfigurationFactory.eINSTANCE.createHyadesDisplayColorDepthCategory());
		this.getValues().add(dcD_1);
		this.getValues().add(dcD_2);
		this.getValues().add(dcD_3);
		this.getValues().add(dcD_4);
		this.getValues().add(dcD_5);
		this.getValues().add(dcD_6);
		this.getValues().add(dcD_7);
		this.getValues().add(dcD_8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return Common_ConfigurationPackage.Literals.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_1() {
		return dcD_1;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_1(String newDCD_1) {
		String oldDCD_1 = dcD_1;
		dcD_1 = newDCD_1;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1, oldDCD_1, dcD_1));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_2() {
		return dcD_2;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_2(String newDCD_2) {
		String oldDCD_2 = dcD_2;
		dcD_2 = newDCD_2;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2, oldDCD_2, dcD_2));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_3() {
		return dcD_3;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_3(String newDCD_3) {
		String oldDCD_3 = dcD_3;
		dcD_3 = newDCD_3;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3, oldDCD_3, dcD_3));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_4() {
		return dcD_4;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_4(String newDCD_4) {
		String oldDCD_4 = dcD_4;
		dcD_4 = newDCD_4;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4, oldDCD_4, dcD_4));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_5() {
		return dcD_5;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_5(String newDCD_5) {
		String oldDCD_5 = dcD_5;
		dcD_5 = newDCD_5;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5, oldDCD_5, dcD_5));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_6() {
		return dcD_6;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_6(String newDCD_6) {
		String oldDCD_6 = dcD_6;
		dcD_6 = newDCD_6;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6, oldDCD_6, dcD_6));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_7() {
		return dcD_7;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_7(String newDCD_7) {
		String oldDCD_7 = dcD_7;
		dcD_7 = newDCD_7;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7, oldDCD_7, dcD_7));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDCD_8() {
		return dcD_8;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDCD_8(String newDCD_8) {
		String oldDCD_8 = dcD_8;
		dcD_8 = newDCD_8;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8, oldDCD_8, dcD_8));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1:
				return getDCD_1();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2:
				return getDCD_2();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3:
				return getDCD_3();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4:
				return getDCD_4();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5:
				return getDCD_5();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6:
				return getDCD_6();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7:
				return getDCD_7();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8:
				return getDCD_8();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1:
				setDCD_1((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2:
				setDCD_2((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3:
				setDCD_3((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4:
				setDCD_4((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5:
				setDCD_5((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6:
				setDCD_6((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7:
				setDCD_7((String)newValue);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8:
				setDCD_8((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1:
				setDCD_1(DCD_1_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2:
				setDCD_2(DCD_2_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3:
				setDCD_3(DCD_3_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4:
				setDCD_4(DCD_4_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5:
				setDCD_5(DCD_5_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6:
				setDCD_6(DCD_6_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7:
				setDCD_7(DCD_7_EDEFAULT);
				return;
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8:
				setDCD_8(DCD_8_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_1:
				return DCD_1_EDEFAULT == null ? dcD_1 != null : !DCD_1_EDEFAULT.equals(dcD_1);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_2:
				return DCD_2_EDEFAULT == null ? dcD_2 != null : !DCD_2_EDEFAULT.equals(dcD_2);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_3:
				return DCD_3_EDEFAULT == null ? dcD_3 != null : !DCD_3_EDEFAULT.equals(dcD_3);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_4:
				return DCD_4_EDEFAULT == null ? dcD_4 != null : !DCD_4_EDEFAULT.equals(dcD_4);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_5:
				return DCD_5_EDEFAULT == null ? dcD_5 != null : !DCD_5_EDEFAULT.equals(dcD_5);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_6:
				return DCD_6_EDEFAULT == null ? dcD_6 != null : !DCD_6_EDEFAULT.equals(dcD_6);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_7:
				return DCD_7_EDEFAULT == null ? dcD_7 != null : !DCD_7_EDEFAULT.equals(dcD_7);
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION__DCD_8:
				return DCD_8_EDEFAULT == null ? dcD_8 != null : !DCD_8_EDEFAULT.equals(dcD_8);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (DCD_1: ");
		result.append(dcD_1);
		result.append(", DCD_2: ");
		result.append(dcD_2);
		result.append(", DCD_3: ");
		result.append(dcD_3);
		result.append(", DCD_4: ");
		result.append(dcD_4);
		result.append(", DCD_5: ");
		result.append(dcD_5);
		result.append(", DCD_6: ");
		result.append(dcD_6);
		result.append(", DCD_7: ");
		result.append(dcD_7);
		result.append(", DCD_8: ");
		result.append(dcD_8);
		result.append(')');
		return result.toString();
	}

} //HyadesDisplayColorDepthEnumerationImpl
