/**********************************************************************
 * Copyright (c) 2005, 2006 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ICommonConstants.java,v 1.4 2006-09-05 15:53:22 sleeloy Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.tptp.platform.common.internal;

public interface ICommonConstants {
	public static final String PROFILE_AGENT_TYPE = "Profiler";

	public static final String LOG_AGENT_TYPE = "Logging";

	public static final String PROFILE_AGENT_NAME = "Java Profiling Agent";

	public static final String J2EE_AGENT_NAME = "J2EE Request Profiler";

	public static final String LOG_AGENT_NAME = "Default Logging Agent";
	
	public static final String HOST_KEY = "use_host";

	public static final String SECURE_USERID = "user_id";

	public static final String LOCALHOST_PORT = "localhost_port";
	
	public static final String CONST_CBES_HEADER = "<CommonBaseEvents xmlns=\"http://www.ibm.com/AC/commonbaseevent1_0_1\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.ibm.com/AC/commonbaseevent1_0_1 commonbaseevent1_0_1.xsd\">";
	
	public static final String CONST_CBES_FOOTER = "</CommonBaseEvents>";	

	public static final int LAYOUT_FLAT = 0;
	
	public static final int LAYOUT_HIERARCHICAL = 1;
	
	public static final String MONITOR_EXT = "trcmxmi";

	public static final String NODE_EXT = "trcnxmi";

	public static final String AGENT_EXT = "trcaxmi";

	public static final String PROCESS_EXT = "trcpxmi";

	public static final String SDB_EXT     = "trcdbxmi";
	
	public static final String SDB_SYMP_EXT= "symptom";
	
	public static final String CORR_EXT    = "corrxmi";
	
	public static final String AGENT_DB_EXT= "trcadb";
	
	public static final String SDB_DB_EXT  = "symptomdb";

}
