/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IDObject.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on 24 nov. 2003
 *
 */
package org.eclipse.tptp.platform.report.core.internal;


/**
 * Provides a General global interface for all interfaces and classes in the tptp charting and reporting component.
 * Used as a "tag" interface usefull for parsers (cf. {@link org.eclipse.tptp.platform.report.tools#DParser})
 * 
 *  @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 *  
 */
public interface IDObject 
{
}
