/********************************************************************** 
 * Copyright (c) 2008, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at 
 * http://www.eclipse.org/legal/epl-v10.html         
 * $Id: class_inerface_int.h,v 1.4 2009-09-10 21:17:43 jcayne Exp $ 
 * 
 * Contributors: 
 * Intel - Initial API and implementation 
 **********************************************************************/ 

#ifndef _CLASS_INTERFACE_INT_H_
#define _CLASS_INTERFACE_INT_H_

//typedef u1 uint8;
//typedef u2 uint16;
//#include "class_interface.h"
//#include "class_interface_x.h"

#include "x_class_interface.h"
#include "x_verifier.h"

#include "JClassBuilder.h"

typedef Class_Handle class_handler;
typedef Method_Handle method_handler;
typedef void *(*get_vm_pointer_t)(void **);

class_handler get_class_handler_from_builder(class CModuleJ *);
method_handler get_method_handler_for_cmethod(class CMethod *);

//extern "C" {
//unsigned method_get_bytecode_length( method_handler);
//}

extern int initialize_dynamic(get_vm_pointer_t);
void class_destroy_handler(class_handler);

int initialize_static();

#endif
