/********************************************************************** 
 * Copyright (c) 2008, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0 
 * which accompanies this distribution, and is available at 
 * http://www.eclipse.org/legal/epl-v10.html         
 * $Id: class_interface_x.h,v 1.4 2009-09-10 21:17:43 jcayne Exp $ 
 * 
 * Contributors: 
 * Intel - Initial API and implementation 
 **********************************************************************/ 

#ifndef _CLASS_INTERFACE_X_H_
#define _CLASS_INTERFACE_X_H_

typedef unsigned long intptr;


#ifdef __cplusplus
//extern "C" {
#endif

#if 0
#include "class_interface.h"
#include "x_verifier.h"
#else
#define __INSURE__
#include "verifier-ext/class_interface.h"
#include "verifier-ext/x_verifier.h"
#endif

// removes given exception handler (handlers with greater indexes shift)
void method_remove_exc_handler( method_handler method, unsigned short idx );

//modifies start_pc, end_pc 
void method_modify_exc_handler_info(method_handler method, 
                                    unsigned short idx, 
                                    unsigned short start_pc,
                                    unsigned short end_pc, 
                                    unsigned short handler_pc, 
                                    unsigned short handler_cp_index );
unsigned short class_get_cp_class_entry(class_handler k_class, const char* name);
#ifdef __cplusplus
//}
#endif
#endif /*!_CLASS_INTERFACE_X_H_*/
