/**********************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: KeystoreManagerFactory.java,v 1.4 2005-10-03 22:03:03 gnagarajan Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.tptp.platform.execution.security;


/**
 * <B>This class is not implemented in TPTP 4.1</B>
 */
public class KeystoreManagerFactory {

	/** 
	 * Create the Security Key Store Manager
	 */
	@SuppressWarnings("rawtypes")
	public static IKeystoreManager createKeystoreManager(String provider)  {

		try {
			Class classObject = Class.forName(provider);
			IKeystoreManager manager=(IKeystoreManager)classObject.newInstance();
			return manager;
		}
		catch(Throwable e) {
		}
        return null;
	}


}
